messages = [
    {'title': 'Event Planning',
     'body':
    """"Event planning is more than just the invite process - there's also the step
    before that, planning, and the step after inviting, sharing media + feedback
    from the event. Most apps only enable you to do one aspect of planning,
    whereas Wave lets you do it all (and all in one wave). Also works well if
    planning events with pre-existing groups. Since Wave lets you communicate
    quickly or at a delayed pace, you can plan some aspects quickly, take more
    time to discuss other aspects."""
    },
    {'title': 'Language Learning',
     'body':
    """Language learning involves a number of aspects - there's the vocabulary,
    there's grammar/syntax, there's pronunciation, and there's what I find
    hardest at all: actually being able to hold real-life conversations. There
    are flashcard apps and online learning apps for the vocabulary, syntax, and
    pronunciation bits, but there are few ways to easily practice real-life
    conversations. 

    It turns out that Google Wave is fairly good for this, because of the
    features of collaborative editing, replying, and extensions. You can find a
    friend (or a stranger on Twitter- people love to teach others their
    language), start a wave with them, and have them ask you questions in the
    language of choice. After you respond, they can go back and edit your answer
    to be correct (assuming it had errors, of course). Then you can see the
    difference when you edit the wave, using the default diff-on-open feature
    (edits in yellow, deletions crossed out). You can later use playback to
    remind yourself how the sentence was changed, and remember what errors you
    often make."""
    },
    {'title': 'Writing',
     'body':
    """There are various apps for drafting documents out there - Google Docs,
    EtherPad, MS Word, etc. The problem I have with all of them is that they do
    not make it easy to have true inline discussions about aspects of a writing
    piece. You can insert comments and try to have discussions that way, but
    they will be single threaded and hard to remove later. You can chat, but
    it's hard to reference parts of the doc in a chat. That's why I love Wave- I
    can write up a draft in a blip, add my editors, respond to their inline
    comments, collapse them when they've approved, and then export my writing to
    its final place (blogger, forum, etc)."""
    },
    {'title': 'Note Taking',
     'body':
    """People like to hear talks and have discussions in person, but also record
    those discussions in a written form to reference later. In meetings, there
    is typically 1 person elected to take notes. In conferences, there is
    sometimes 1 person elected (or volunteered), and sometimes no one is
    elected, and a random set of delegates take their own personal notes in a
    notepad or doc (and possibly blog them later). 
    
    There are issues with both these techniques, however. When only 1 person
    takes notes, they often cannot edit fast enough to capture everything, or
    they often get distracted for a few minutes, and then have no record for a
    particular segment. When multiple people take their own notes, there is no
    good, fast way to merge them together later."""
    },
    {'title': 'Design Docs',
     'body':
    """This is a particular instance of writing a draft, but it is a useful
    enough use case that I want to point it out in particular. Developers often
    write design docs, and ask for comment on them, and I find it can be
    intimidating to respond to those rather long documents. But if I can respond
    to just one bit of it, then it becomes easier. 
    
    In addition, waves can contain more dynamic content, like gadgets and
    iframes, so design doc waves can actually include the project being
    designed, if it is web based.
    
    It also becomes easy to update the design doc as you make progress on the
    project, and make it be a living, breathing representation of that project.
    People who are curious about the evolution of the design can simply replay
    the doc."""
    },
    {'title': 'Bug Tracking',
     'body':
    """One aspect of my job is triaging bugs with my colleagues - going through
    newly reported issues in our issue tracker, figuring out which are valid,
    and reporting them to the team. My colleague and I live on opposite sides of
    the world, and figured the easiest way to triage would be using Wave. We
    start by grabbing a linked list of the newly opened issues and paste that in
    the wave. Then we each reply to the ones we're looking at to basically call
    dibs on it ("Looking at it"), and when we have questions or want to discuss,
    we have an inline conversation under the bug. It works really well, because
    we are able to work separately but together - we work in parallel, and
    converse about eachother's bugs on the side. It equates to triaging the new
    issues in almost half the time."""
    },
    {'title': 'CMS',
     'body':
    """Many websites are built on some sort of content management system, where
    articles can be created, moved into different sections, etc. Most (possibly
    all) of these CMS systems do not allow for real-time collaborative editing
    of content, however, a highly useful feature for rapidly changing
    information. This is where Wave comes in - editors can use it to
    collaboratively create the content, then export that to their website, and
    present it however they'd like."""
    }]
